/*
	SambaScanner - A tool to scan Samba networks for files.
	Copyright (C) 2005 Johannes Bauer
	
	This file is part of SambaScanner.

    SambaScanner is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; this program is ONLY licensed under
	version 2 of the License, later versions are explicitly excluded.

    SambaScanner is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SambaScanner; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Johannes Bauer
	Mussinanstr. 140
	92318 Neumarkt/Opf.
	JohannesBauer@gmx.de
*/

#include <stdio.h>
#include <pthread.h>

#include "Semaphore.h"

void Semaphore_Init(struct Semaphore_Data *SemData, int InitValue) {
	SemData->Value = InitValue;
	pthread_mutex_init(&(SemData->Mutex), NULL);
	pthread_cond_init(&(SemData->Signal), NULL);
}

/* Dekrementieren */
void P(struct Semaphore_Data *SemData) {
	int Sleep;
	
/*	printf("Semaphore -- [%d => %d]!\n", SemData->Value, SemData->Value-1); */
	pthread_mutex_lock(&(SemData->Mutex));
	do {
		Sleep=0;
		if (SemData->Value==0) {
			Sleep=1;
			pthread_cond_wait(&(SemData->Signal), &(SemData->Mutex));
		}
	} while (Sleep==1);
	SemData->Value--;
	pthread_mutex_unlock(&(SemData->Mutex));
}

/* Inkrementieren */
void V(struct Semaphore_Data *SemData) {
/*	printf("Semaphore ++ [%d => %d]!\n", SemData->Value, SemData->Value+1); */
	pthread_mutex_lock(&(SemData->Mutex));
	SemData->Value++;
	if (SemData->Value==1) {
		pthread_cond_broadcast(&(SemData->Signal));
	}
	pthread_mutex_unlock(&(SemData->Mutex));
}

