/*
	SambaScanner - A tool to scan Samba networks for files.
	Copyright (C) 2005 Johannes Bauer
	
	This file is part of SambaScanner.

    SambaScanner is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; this program is ONLY licensed under
	version 2 of the License, later versions are explicitly excluded.

    SambaScanner is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SambaScanner; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Johannes Bauer
	Mussinanstr. 140
	92318 Neumarkt/Opf.
	JohannesBauer@gmx.de
*/

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <sys/wait.h>
#include <time.h>
#include <pthread.h>
#include <sys/timeb.h>

#include "Mutex.h"
#include "Parser.h"

void* TestThread(void *Argument) {
	int i;
	HostCnt_Inc();
	i=(rand()%1000)+100;
	printf("Started and exited testthread %d [sleep %d]\n", (int)Argument, i);
	usleep(1000*i);
	HostCnt_Dec();
	return NULL;
}

int main(int argc, char **argv) {
	int i;
	pthread_t Threads[150];

	printf("Checking semaphores...\n");
	Init_Semaphores();

	for (i=0; i<150; i++) {
		printf("init thread i = %d\n", i);
		pthread_create(&Threads[i], NULL, TestThread, (void*)i);
	}

	sleep(15);
	printf("End of loop!\n");
	printf("Waiting for termination...\n");
	Waitfor_HostCnt();
	printf("Waiting for termination finished!\n");
	while (1) {
		printf("This is bad!\n");
		sleep(1);
	}
	
	return 0;
}
